<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\LineStop;
use App\Models\User;

class LineStopPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any LineStop');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, LineStop $linestop): bool
    {
        return $user->checkPermissionTo('view LineStop');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create LineStop');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, LineStop $linestop): bool
    {
        return $user->checkPermissionTo('update LineStop');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, LineStop $linestop): bool
    {
        return $user->checkPermissionTo('delete LineStop');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any LineStop');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, LineStop $linestop): bool
    {
        return $user->checkPermissionTo('restore LineStop');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any LineStop');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, LineStop $linestop): bool
    {
        return $user->checkPermissionTo('replicate LineStop');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder LineStop');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, LineStop $linestop): bool
    {
        return $user->checkPermissionTo('force-delete LineStop');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any LineStop');
    }
}
